PF-build.sh 37 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_28
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to scrpit commits
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. #### Start check if OSTYPE is supported
  131. OS_FOUND=$( command -v uname)
  132. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  133. linux*)
  134. TARGET_OS="linux"
  135. ;;
  136. msys*|cygwin*|mingw*)
  137. # or possible 'bash on windows'
  138. TARGET_OS='windows'
  139. ;;
  140. nt|win*)
  141. TARGET_OS='windows'
  142. ;;
  143. *)
  144. TARGET_OS='unknown'
  145. ;;
  146. esac
  147. # Windows
  148. if [ $TARGET_OS == "windows" ]; then
  149. if [ $(uname -m) == "x86_64" ]; then
  150. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  151. Processor="64"
  152. elif [ $(uname -m) == "i386" ]; then
  153. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  154. Processor="32"
  155. else
  156. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  157. echo "Please refer to the notes of build.sh$(tput sgr0)"
  158. exit 1
  159. fi
  160. # Linux
  161. elif [ $TARGET_OS == "linux" ]; then
  162. if [ $(uname -m) == "x86_64" ]; then
  163. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  164. Processor="64"
  165. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  166. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  167. Processor="32"
  168. else
  169. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  170. echo "Please refer to the notes of build.sh$(tput sgr0)"
  171. exit 1
  172. fi
  173. else
  174. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  175. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  176. echo "Read the notes of build.sh$(tput sgr0)"
  177. exit 1
  178. fi
  179. sleep 2
  180. #### End check if OSTYPE is supported
  181. #### Prepare bash environment and check if wget, zip and other needed things are available
  182. # Check wget
  183. if ! type wget > /dev/null; then
  184. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  185. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  186. exit 2
  187. fi
  188. # Check for zip
  189. if ! type zip > /dev/null; then
  190. if [ $TARGET_OS == "windows" ]; then
  191. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  192. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  193. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  194. echo "Run git Bash under Administrator privilege and"
  195. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  196. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  197. exit 3
  198. elif [ $TARGET_OS == "linux" ]; then
  199. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  200. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  201. exit 3
  202. fi
  203. fi
  204. # Check python ... needed during language build
  205. if ! type python > /dev/null; then
  206. if [ $TARGET_OS == "windows" ]; then
  207. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  208. exit 4
  209. elif [ $TARGET_OS == "linux" ]; then
  210. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  211. echo "As Python 2.x will not be maintained from 2020 please,"
  212. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  213. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  214. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  215. exit 4
  216. fi
  217. fi
  218. #### End prepare bash / Linux environment
  219. #### Set build environment
  220. ARDUINO_ENV="1.8.5"
  221. BUILD_ENV="1.0.6"
  222. BOARD="prusa_einsy_rambo"
  223. BOARD_PACKAGE_NAME="PrusaResearch"
  224. BOARD_VERSION="1.0.3"
  225. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  226. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  227. BOARD_FILENAME="prusa3dboards"
  228. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  229. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  230. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  231. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  232. LIB="PrusaLibrary"
  233. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  234. # List few useful data
  235. echo
  236. echo "Script path :" $SCRIPT_PATH
  237. echo "OS :" $OS
  238. echo "OS type :" $TARGET_OS
  239. echo ""
  240. echo "Ardunio IDE :" $ARDUINO_ENV
  241. echo "Build env :" $BUILD_ENV
  242. echo "Board :" $BOARD
  243. echo "Package name:" $BOARD_PACKAGE_NAME
  244. echo "Board v. :" $BOARD_VERSION
  245. echo "Specific Lib:" $LIB
  246. echo ""
  247. #### Start prepare building environment
  248. #Check if build exists and creates it if not
  249. if [ ! -d "../PF-build-dl" ]; then
  250. mkdir ../PF-build-dl || exit 5
  251. fi
  252. cd ../PF-build-dl || exit 6
  253. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  254. # Check if PF-build-env-<version> exists and downloads + creates it if not
  255. # The build environment is based on the supported Arduino IDE portable version with some changes
  256. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  257. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  258. mkdir ../PF-build-env-$BUILD_ENV
  259. sleep 5
  260. fi
  261. # Download and extract supported Arduino IDE depending on OS
  262. # Windows
  263. if [ $TARGET_OS == "windows" ]; then
  264. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  265. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  266. sleep 2
  267. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  268. echo "$(tput sgr 0)"
  269. fi
  270. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  271. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  272. sleep 2
  273. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  274. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  275. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  276. echo "$(tput sgr0)"
  277. fi
  278. fi
  279. # Linux
  280. if [ $TARGET_OS == "linux" ]; then
  281. # 32 or 64 bit version
  282. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  283. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  284. sleep 2
  285. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  286. echo "$(tput sgr 0)"
  287. fi
  288. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  289. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  290. sleep 2
  291. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  292. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  293. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  294. echo "$(tput sgr0)"
  295. fi
  296. fi
  297. # Make Arduino IDE portable
  298. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  299. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  300. fi
  301. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  302. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  303. fi
  304. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  305. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  306. fi
  307. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  308. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  309. fi
  310. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  311. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  312. fi
  313. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  314. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  315. fi
  316. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  317. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  318. fi
  319. # Change Arduino IDE preferences
  320. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  321. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  322. sleep 2
  323. echo "update.check"
  324. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  325. echo "board"
  326. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  327. echo "editor.linenumbers"
  328. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  329. echo "boardsmanager.additional.urls"
  330. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  331. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  332. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  333. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  334. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  335. echo "$(tput sgr0)"
  336. fi
  337. # Download and extract Prusa Firmware related parts
  338. # Download and extract PrusaResearchRambo board
  339. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  340. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  341. sleep 2
  342. wget $BOARD_FILE_URL || exit 9
  343. fi
  344. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  345. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  346. sleep 2
  347. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  348. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  349. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  350. fi
  351. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  352. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  353. fi
  354. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  355. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  356. fi
  357. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  358. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  359. fi
  360. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  361. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  362. echo "$(tput sgr 0)"
  363. fi
  364. # Download and extract Prusa Firmware specific library files
  365. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  366. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  367. sleep 2
  368. wget $PF_BUILD_FILE_URL || exit 11
  369. echo "$(tput sgr 0)"
  370. fi
  371. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  372. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  373. sleep 2
  374. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  375. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  376. echo "$(tput sgr0)"
  377. fi
  378. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  379. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  380. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  381. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  382. sleep 2
  383. fi
  384. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  385. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  386. sleep 2
  387. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  388. sleep 2
  389. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  390. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  391. echo "$(tput sgr0)"
  392. fi
  393. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  394. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  395. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  396. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  397. sleep 2
  398. echo "$(tput sgr0)"
  399. exit 13
  400. fi
  401. #### End prepare building
  402. #### Start
  403. cd $SCRIPT_PATH
  404. # First argument defines which variant of the Prusa Firmware will be compiled
  405. if [ -z "$1" ] ; then
  406. # Select which variant of the Prusa Firmware will be compiled, like
  407. PS3="Select a variant: "
  408. while IFS= read -r -d $'\0' f; do
  409. options[i++]="$f"
  410. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  411. select opt in "${options[@]}" "All" "Quit"; do
  412. case $opt in
  413. *.h)
  414. VARIANT=$(basename "$opt" ".h")
  415. VARIANTS[i++]="$opt"
  416. break
  417. ;;
  418. "All")
  419. VARIANT="All"
  420. VARIANTS=${options[*]}
  421. break
  422. ;;
  423. "Quit")
  424. echo "You chose to stop"
  425. exit
  426. ;;
  427. *)
  428. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  429. ;;
  430. esac
  431. done
  432. else
  433. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  434. VARIANTS=$1
  435. else
  436. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  437. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  438. echo "$(tput sgr0)"
  439. exit 21
  440. fi
  441. fi
  442. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  443. #Check default language mode
  444. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  445. if [ -z "$2" ] ; then
  446. PS3="Select a language: "
  447. echo
  448. echo "Which lang-build do you want?"
  449. select yn in "Multi languages" "English only"; do
  450. case $yn in
  451. "Multi languages")
  452. LANGUAGES="ALL"
  453. break
  454. ;;
  455. "English only")
  456. LANGUAGES="EN_ONLY"
  457. break
  458. ;;
  459. *)
  460. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  461. ;;
  462. esac
  463. done
  464. else
  465. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  466. LANGUAGES=$2
  467. else
  468. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  469. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  470. exit 22
  471. fi
  472. fi
  473. #Check if DEV_STATUS is selected via argument 3
  474. if [ ! -z "$3" ] ; then
  475. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" || "$3" == "UNKNOWN" ]] ; then
  476. DEV_STATUS_SELECTED=$3
  477. else
  478. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  479. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKOWN' $(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  480. exit 23
  481. fi
  482. fi
  483. #Set BUILD_ENV_PATH
  484. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  485. BUILD_ENV_PATH="$( pwd -P )"
  486. cd ../..
  487. #Checkif BUILD_PATH exists and if not creates it
  488. if [ ! -d "Prusa-Firmware-build" ]; then
  489. mkdir Prusa-Firmware-build || exit 25
  490. fi
  491. #Set the BUILD_PATH for Arduino IDE
  492. cd Prusa-Firmware-build || exit 26
  493. BUILD_PATH="$( pwd -P )"
  494. for v in ${VARIANTS[*]}
  495. do
  496. VARIANT=$(basename "$v" ".h")
  497. # Find firmware version in Configuration.h file and use it to generate the hex filename
  498. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  499. # Find build version in Configuration.h file and use it to generate the hex filename
  500. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  501. # Check if the motherboard is an EINSY and if so only one hex file will generated
  502. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  503. # Check development status
  504. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  505. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  506. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  507. DEV_STATUS="RC"
  508. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  509. DEV_STATUS="ALPHA"
  510. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  511. DEV_STATUS="BETA"
  512. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  513. DEV_STATUS="DEVEL"
  514. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  515. DEV_STATUS="DEBUG"
  516. else
  517. DEV_STATUS="UNKNOWN"
  518. echo
  519. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  520. PS3="Select YES only if source code is tested and trusted: "
  521. select yn in "Yes" "No"; do
  522. case $yn in
  523. Yes)
  524. DEV_STATUS="GOLD"
  525. DEV_STATUS_SELECTED="GOLD"
  526. break
  527. ;;
  528. No)
  529. DEV_STATUS="UNKNOWN"
  530. DEV_STATUS_SELECTED="UNKNOWN"
  531. break
  532. ;;
  533. *)
  534. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  535. ;;
  536. esac
  537. done
  538. fi
  539. else
  540. DEV_STATUS=$DEV_STATUS_SELECTED
  541. fi
  542. #Prepare hex files folders
  543. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  544. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  545. fi
  546. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  547. #Check if exactly the same hexfile already exists
  548. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  549. echo ""
  550. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  551. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  552. read -t 10 -p "Press Enter to continue..."
  553. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  554. echo ""
  555. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  556. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  557. read -t 10 -p "Press Enter to continue..."
  558. fi
  559. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  560. echo ""
  561. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  562. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  563. read -t 10 -p "Press Enter to continue..."
  564. fi
  565. #List some useful data
  566. echo "$(tput setaf 2)$(tput setab 7) "
  567. echo "Variant :" $VARIANT
  568. echo "Firmware :" $FW
  569. echo "Build # :" $BUILD
  570. echo "Dev Check :" $DEV_CHECK
  571. echo "DEV Status :" $DEV_STATUS
  572. echo "Motherboard:" $MOTHERBOARD
  573. echo "Languages :" $LANGUAGES
  574. echo "Hex-file Folder:" $OUTPUT_FOLDER
  575. echo "$(tput sgr0)"
  576. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  577. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  578. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  579. else
  580. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  581. read -t 10 -p "Press Enter to continue..."
  582. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  583. fi
  584. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  585. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  586. # set FW_REPOSITORY
  587. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  588. #Prepare english only or multilanguage version to be build
  589. if [ $LANGUAGES == "EN_ONLY" ]; then
  590. echo " "
  591. echo "English only language firmware will be built"
  592. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  593. echo " "
  594. else
  595. echo " "
  596. echo "Multi-language firmware will be built"
  597. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  598. echo " "
  599. fi
  600. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  601. # if [ $TARGET_OS == "windows" ]; then
  602. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  603. # fi
  604. #### End of Prepare building
  605. #### Start building
  606. export ARDUINO=$BUILD_ENV_PATH
  607. #echo $BUILD_ENV_PATH
  608. #export BUILDER=$ARDUINO/arduino-builder
  609. echo
  610. #read -t 5 -p "Press Enter..."
  611. echo
  612. echo "Start to build Prusa Firmware ..."
  613. echo "Using variant $VARIANT$(tput setaf 3)"
  614. sleep 2
  615. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  616. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  617. echo "$(tput sgr 0)"
  618. if [ $LANGUAGES == "ALL" ]; then
  619. echo "$(tput setaf 2)"
  620. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  621. echo "$(tput sgr 0)"
  622. sleep 2
  623. cd $SCRIPT_PATH/lang
  624. echo "$(tput setaf 3)"
  625. ./config.sh || exit 31
  626. echo "$(tput sgr 0)"
  627. # Check if previous languages and firmware build exist and if so clean them up
  628. if [ -f "lang_en.tmp" ]; then
  629. echo ""
  630. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  631. read -t 10 -p "Press Enter to continue..."
  632. echo "$(tput setaf 3)"
  633. ./lang-clean.sh
  634. echo "$(tput sgr 0)"
  635. fi
  636. if [ -f "progmem.out" ]; then
  637. echo ""
  638. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  639. read -t 10 -p "Press Enter to continue..."
  640. echo "$(tput setaf 3)"
  641. ./fw-clean.sh
  642. echo "$(tput sgr 0)"
  643. fi
  644. # build languages
  645. echo "$(tput setaf 3)"
  646. ./lang-build.sh || exit 32
  647. # Combine compiled firmware with languages
  648. ./fw-build.sh || exit 33
  649. cp not_tran.txt not_tran_$VARIANT.txt
  650. cp not_used.txt not_used_$VARIANT.txt
  651. echo "$(tput sgr 0)"
  652. # Check if the motherboard is an EINSY and if so only one hex file will generated
  653. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  654. # If the motherboard is an EINSY just copy one hexfile
  655. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  656. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  657. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  658. else
  659. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  660. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  661. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  662. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  663. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  664. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  665. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  666. if [ $TARGET_OS == "windows" ]; then
  667. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  668. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  669. elif [ $TARGET_OS == "linux" ]; then
  670. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  671. fi
  672. fi
  673. # Cleanup after build
  674. echo "$(tput setaf 3)"
  675. ./fw-clean.sh || exit 34
  676. ./lang-clean.sh || exit 35
  677. echo "$(tput sgr 0)"
  678. else
  679. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  680. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  681. fi
  682. # Cleanup Firmware
  683. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  684. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  685. then
  686. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  687. fi
  688. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  689. then
  690. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  691. fi
  692. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  693. then
  694. rm $SCRIPT_PATH/lang/not_tran.txt
  695. fi
  696. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  697. then
  698. rm $SCRIPT_PATH/lang/not_used.txt
  699. fi
  700. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  701. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  702. echo $MULTI_LANGUAGE_CHECK
  703. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  704. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  705. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  706. sleep 5
  707. done
  708. # Switch to hex path and list build files
  709. cd $SCRIPT_PATH
  710. cd ..
  711. echo "$(tput setaf 2) "
  712. echo " "
  713. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  714. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  715. #### End building